--------------------------------------------------------------------------------
-- Standard circuit hexadecimal to seven segment decoder 
-- Behavioural approach. 
-- The truth table is written translating the schematic and simply using buffers 
-- to adapt the truth table artefact to inputs and outputs   
-- 
---------------------------------------------------
-- Project P2  - CSD : standard logic circuits in VHDL
-- http://digsys.upc.edu
--------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity HEX_7SEG_VHDL is

		port (
			V_ENT: in STD_LOGIC_VECTOR(3 downto 0);       
			V_SOR: out STD_LOGIC_VECTOR (6 downto 0)
			  );

end HEX_7SEG_VHDL;



architecture Arch_Taula_Veritat of HEX_7SEG_VHDL is
begin

			with V_ENT select      
	        	--		          abcdefg        DCBA
	                --                        -------        ----
					V_SOR <= "1111110" when "0000",        -- 0 
			 		   	 "0110000" when "0001",        -- 1
			 		   	 "1101101" when "0010",	       -- 2
			 		   	 "1111001" when "0011",	       -- 3		   
			 		   	 "0110011" when "0100",        -- 4
			 		   	 "1011011" when "0101",        -- 5 
			 		   	 "1011111" when "0110",        -- 6
			 		   	 "1110000" when "0111",        -- 7
			 		   	 "1111111" when "1000",        -- 8
			 		   	 "1110011" when "1001",        -- 9
			 		   	 "1110111" when "1010",        -- A
			 		   	 "0011111" when "1011",        -- b
			 		   	 "1001110" when "1100",        -- C
			 		   	 "0111101" when "1101",        -- d
			 		   	 "1001111" when "1110",        -- E
			 		   	 "1000111" when others;	       -- F
			 		   	 		 		   	   	

end Arch_Taula_Veritat;

